#include "avl_sid.hpp"

avl_sid_data::avl_sid_data(PSID new_sid,const unsigned char *new_AccounName,const unsigned char *new_DomainName)
{
  sid_length=GetLengthSid(new_sid);
  if(sid_length)
  {
    sid=(PSID)HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,sid_length);
    if(sid)
    {
      CopySid(sid_length,sid,new_sid);
      AccounName=new_AccounName;
      DomainName=new_DomainName;
    }
  }
}

avl_sid_data::~avl_sid_data()
{
  if(sid) HeapFree(GetProcessHeap(),0,sid);
}

avl_sid_tree::avl_sid_tree()
{
  clear();
}

avl_sid_tree::~avl_sid_tree()
{
  clear();
}

long avl_sid_tree::compare(avl_node<avl_sid_data> *first,avl_sid_data *second)
{
  DWORD compare_length=first->data->sid_length>second->sid_length?second->sid_length:first->data->sid_length;
  long result=memcmp(second->sid,first->data->sid,compare_length);
  if(!result) result=second->sid_length-first->data->sid_length;
  return result;
}

avl_sid_data *avl_sid_tree::query(PSID value)
{
  avl_sid_data Get(value);
  return avl_tree<avl_sid_data>::query(&Get);
}
